classification
Title: Launcher fails to find in-place built binaries from earlier Python versions
Type: behavior Stage: resolved
Components: Windows Versions: Python 3.6, Python 3.5
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: mhammond Nosy List: mhammond, paul.moore, python-dev, steve.dower, tim.golden, vinay.sajip, zach.ware
Priority: normal Keywords: patch

Created on 2016-01-10 00:59 by mhammond, last changed 2016-01-16 21:50 by steve.dower. This issue is now closed.

Files
File name Uploaded Description Edit
launcher.patch mhammond, 2016-01-10 00:59 review
Messages (6)
msg257878 - (view) Author: Mark Hammond (mhammond) * (Python committer) Date: 2016-01-10 00:59
The launcher was recently updated to look in PCBuild/win32 to support the win32 binaries being built in this directory instead of the top-level PCBuild directory. However, when this new launcher tries to find a binary for, say, Python 2.7, it doesn't find an executable because it's directly in PCBuild, not one of the win32 or amd64 sub-directories.

Note this only impacts Python when it is built in the directory - it doesn't impact installed versions.

The fix I came up with is to continue looking in PCBuild if it isn't found in one of those dirs.

Vinay, what do you think?
msg257886 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2016-01-10 04:21
I don't think Vinay does much wrt the launcher in core anymore, it's mostly been me recently.

I don't see any harm in this change, though I'll admit I also don't see the point. When is the launcher ever going to find Python built in-place?
msg257897 - (view) Author: Mark Hammond (mhammond) * (Python committer) Date: 2016-01-10 07:55
> When is the launcher ever going to find Python built in-place?

On the machine that built Python in-place :) I have a dev environment where all Python versions and pywin32 are built and that's the environment where py.exe is failing. My build scripts use py.exe to build for a specific Python version.

It sounds like you are fine with it, so I'll try and work out how to get a new key up and push it unless I hear otherwise, thanks.
msg257902 - (view) Author: Vinay Sajip (vinay.sajip) * (Python committer) Date: 2016-01-10 10:03
Hey, Steve, don't shut me out, I'm still here ;-)

I've had a heavy consulting load for the past year or so which means I can't always deal with issues as quickly as before. If someone else fixes issues before I get to them, it's fine by me :-)

IMO the proposed change by Mark seems reasonable. It's really only for us devs anyway.
msg257917 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2016-01-10 15:50
> I've had a heavy consulting load for the past year or so which means I can't always deal with issues as quickly as before.

That explains it :) With so little visibility into what we're doing outside of Python it's hard to know. Glad you're still about.
msg257949 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2016-01-11 03:54
New changeset 51cc7adac78d by Mark Hammond in branch '3.5':
Issue #26070: py.exe launcher fails to find in-place built binaries from earlier Python versions.
https://hg.python.org/cpython/rev/51cc7adac78d

New changeset bfb4a09149b1 by Mark Hammond in branch 'default':
Issue #26070: py.exe launcher fails to find in-place built binaries from earlier Python versions.
https://hg.python.org/cpython/rev/bfb4a09149b1
History
Date User Action Args
2016-01-16 21:50:37steve.dowersetstatus: open -> closed
assignee: mhammond
resolution: fixed
stage: resolved
2016-01-11 03:54:13python-devsetnosy: + python-dev
messages: + msg257949
2016-01-10 15:50:05steve.dowersetmessages: + msg257917
2016-01-10 10:03:28vinay.sajipsetmessages: + msg257902
2016-01-10 07:55:57mhammondsetmessages: + msg257897
2016-01-10 04:21:18steve.dowersetmessages: + msg257886
2016-01-10 00:59:35mhammondcreate